//box.cpp



#include <gnome.h>
#include "theme.h"
#include "widget.h"
#include "box.h"


Box::Box()
{
}

void Box::showAll()
{
	gtk_widget_show_all(_widget);
}

void Box::add(Widget* w)
{
	gtk_box_pack_start(GTK_BOX(_widget), w->widget(), FALSE, FALSE, 0);
}

void Box::add(Widget* w, gboolean expand, gboolean fill, guint padding)
{
	gtk_box_pack_start(GTK_BOX(_widget), w->widget(), expand, fill, padding);
}

void Box::add(GtkWidget* widget)
{
	gtk_box_pack_start(GTK_BOX(_widget), widget, FALSE, FALSE, 0);
}

void Box::addEnd(Widget* w)
{
	gtk_box_pack_end(GTK_BOX(_widget), w->widget(), FALSE, FALSE, 0);
}

void Box::addEnd(Widget* w, gboolean expand, gboolean fill, guint padding)
{
	gtk_box_pack_end(GTK_BOX(_widget), w->widget(), expand, fill, padding);
}

void Box::addEnd(GtkWidget* widget)
{
	gtk_box_pack_end(GTK_BOX(_widget), widget, FALSE, FALSE, 0);
}


HBox::HBox(gboolean homogeneous, gint spacing): Box()
{
	_widget = gtk_hbox_new(homogeneous, spacing);
}

VBox::VBox(gboolean homogeneous, gint spacing): Box()
{
	_widget = gtk_vbox_new(homogeneous, spacing);
}
