//clist.cpp



#include <gnome.h>
#include "theme.h"
#include "widget.h"
#include "clist.h"


CList::CList(gint columns)
{
	_widget = gtk_clist_new(columns);
}


//useful
void CList::freeze(gboolean b)
{
	if(b)
		gtk_clist_freeze(GTK_CLIST(_widget));
	else
		gtk_clist_thaw(GTK_CLIST(_widget));
}

gint CList::append(gchar* text[])
{
	return gtk_clist_append(GTK_CLIST(_widget), text);
}

void CList::insert(gint row, gchar* text[])
{
	gtk_clist_insert(GTK_CLIST(_widget), row, text);
}

gint CList::prepend(gchar* text[])
{
	return gtk_clist_prepend(GTK_CLIST(_widget), text);
}

//unset text
void CList::remove(gint row)
{
	gtk_clist_remove(GTK_CLIST(_widget), row);
}

void CList::clear()
{
	gtk_clist_clear(GTK_CLIST(_widget));
}

//misc
void CList::selectRow(gint row, gint column)
{
	gtk_clist_select_row(GTK_CLIST(_widget), row, column);
}

void CList::swapRows(gint row1, gint row2)
{
	gtk_clist_swap_rows(GTK_CLIST(_widget), row1, row2);
}

//get text
gchar* CList::getText(gint row, gint column)
{
	gchar* str;
	gint i = gtk_clist_get_text(GTK_CLIST(_widget), row, column, &str);
	if(i == 0)
		return NULL;
	return str;
}

//user data
void CList::setData(gint row, gpointer data)
{
	gtk_clist_set_row_data(GTK_CLIST(_widget), row, data);
}
