//druid.cpp



#include <gnome.h>
#include "theme.h"
#include "widget.h"
#include "container.h"
#include "box.h"
#include "window.h"
#include "misc.h"
#include "druid.h"



//DruidPage
DruidPage::DruidPage(gchar title[], gchar logo[],
		Color* bg)
{
	_widget = gnome_druid_page_standard_new_with_vals(title, NULL);
	if(bg)
	{
		setColorBg(bg);
		setColorLogoBg(bg);
	}
	else
	{
		//FIXME
		Color blue("blue");
		setColorBg(&blue);
		setColorLogoBg(&blue);
	}
}

//sets
void DruidPage::setTitle(gchar title[])
{
	if(title)
		gnome_druid_page_standard_set_title(GNOME_DRUID_PAGE_STANDARD(_widget),
				title);
}


void DruidPage::setColorBg(Color* color)
{
	gnome_druid_page_standard_set_bg_color(
			GNOME_DRUID_PAGE_STANDARD(_widget),
			color->color());
}

void DruidPage::setColorLogoBg(Color* color)
{
	gnome_druid_page_standard_set_logo_bg_color(GNOME_DRUID_PAGE_STANDARD(_widget),
			color->color());
}


//DruidPageStart
DruidPageStart::DruidPageStart(gchar title[], gchar text[],
		Color* bg)
{
	_widget = gnome_druid_page_start_new_with_vals(title, text, NULL, NULL);
	if(bg)
	{
		setColorBg(bg);
		setColorLogoBg(bg);
	}
	else
	{
		//FIXME
		Color blue("blue");
		setColorBg(&blue);
		setColorLogoBg(&blue);
	}
}

//sets
void DruidPageStart::setTitle(gchar title[])
{
	if(title)
		gnome_druid_page_start_set_title(GNOME_DRUID_PAGE_START(_widget),
				title);
}

void DruidPageStart::setColorBg(Color* color)
{
	gnome_druid_page_start_set_bg_color(
			GNOME_DRUID_PAGE_START(_widget),
			color->color());
}

void DruidPageStart::setColorLogoBg(Color* color)
{
	gnome_druid_page_start_set_logo_bg_color(
			GNOME_DRUID_PAGE_START(_widget),
			color->color());
}


//DruidPageFinish
DruidPageFinish::DruidPageFinish(gchar title[], gchar text[],
		Color* bg)
{
	_widget = gnome_druid_page_finish_new_with_vals(title, text, NULL, NULL);
	if(bg)
	{
		setColorBg(bg);
		setColorLogoBg(bg);
	}
	else
	{
		//FIXME
		Color blue("blue");
		setColorBg(&blue);
		setColorLogoBg(&blue);
	}
}

//sets
void DruidPageFinish::setTitle(gchar title[])
{
	if(title)
		gnome_druid_page_finish_set_title(GNOME_DRUID_PAGE_FINISH(_widget),
				title);
}

void DruidPageFinish::setColorBg(Color* color)
{
	gnome_druid_page_finish_set_bg_color(
			GNOME_DRUID_PAGE_FINISH(_widget),
			color->color());
}

void DruidPageFinish::setColorLogoBg(Color* color)
{
	gnome_druid_page_finish_set_logo_bg_color(GNOME_DRUID_PAGE_FINISH(_widget),
			color->color());
}

//Druid
Druid::Druid()
{
	_widget = gnome_druid_new();
}

//sets
void Druid::setButtonsSensitive(gboolean back, gboolean next, gboolean cancel)
{
	gnome_druid_set_buttons_sensitive(GNOME_DRUID(_widget), back, next, cancel);
}

void Druid::showFinish(gboolean finish)
{
	gnome_druid_set_show_finish(GNOME_DRUID(_widget), finish);
}

void Druid::append(DruidPage* page)
{
	gnome_druid_append_page(GNOME_DRUID(_widget), GNOME_DRUID_PAGE(page->widget()));
}
