//menu.cpp



#include <gnome.h>
#include "theme.h"
#include "widget.h"
#include "separator.h"
#include "menu.h"


//nb should be needed for the GnomeUIInfo array (?)
Menu::Menu(gboolean tearoff): Widget()
{
	GtkWidget* menuitem;

	_widget = gtk_menu_new();
	if(tearoff)
	{
		menuitem = gtk_tearoff_menu_item_new();
		gtk_widget_show(menuitem);
		gtk_menu_prepend(GTK_MENU(_widget), menuitem);
	}
}


void Menu::add(gchar label[], void* callback, gpointer data, gpointer userdata)
{
	GtkWidget* menuitem;

	menuitem = gtk_menu_item_new_with_label(label);
	gtk_widget_show(menuitem);
	if(userdata) gtk_object_set_user_data(GTK_OBJECT(menuitem), userdata);
	if(callback != NULL)
		gtk_signal_connect(GTK_OBJECT(menuitem), "activate", (GtkSignalFunc)callback, data);
	gtk_menu_append(GTK_MENU(_widget), menuitem);
}

void Menu::add(gchar label[], void* callback, gpointer data, gint userdata)
{
	add(label, callback, data, GINT_TO_POINTER(userdata));
}

void Menu::add()
{
	GtkWidget* menuitem;
//	HSeparator* pseparator;

	menuitem = gtk_menu_item_new();
	gtk_widget_show(menuitem);
//	gtk_widget_show(menuitem);
//	gtk_widget_set_sensitive(menuitem, FALSE);
//	pseparator = new HSeparator;
//	pseparator->show();
//	gtk_container_add(GTK_CONTAINER(menuitem), pseparator->widget());
	gtk_menu_append(GTK_MENU(_widget), menuitem);
}

gint _x, _y;
static void gtk_menu_position(GtkMenu *menu, gint *x, gint *y, gpointer user_data);
void Menu::popup(gint x, gint y, gchar title[])
{
	_x = x; _y = y;
	GtkWidget* menuitem = gtk_menu_item_new_with_label(title);
	gtk_widget_show(menuitem);
	gtk_menu_popup(GTK_MENU(_widget), NULL, menuitem, gtk_menu_position, NULL, 2, 0);
}

static void gtk_menu_position(GtkMenu *menu, gint *x, gint *y, gpointer user_data)
{
	*x = _x;
	*y = _y;
}
