//misc.cpp



#include <gtk/gtk.h>
#include "theme.h"
#include "widget.h"
#include "container.h"
#include "box.h"
#include "window.h"
#include "misc.h"



//main func
guint TimeoutAdd(guint32 interval, void* function, gpointer data)
{
	return gtk_timeout_add(interval, (GtkFunction)function, data);
}


void TimeoutRemove(guint32 timeout)
{
	gtk_timeout_remove(timeout);
}

gint IdleAdd(void* function, gpointer data)
{
	return gtk_idle_add((GtkFunction)function, data);
}

void IdleRemove(gint idle)
{
	gtk_idle_remove(idle);
}

//misc func
GtkWidget* newPixmapFromXpm(char* xpm[], Window* window)
{
	GtkWidget* pixmap;
	GdkBitmap* mask;
	GdkPixmap* gdkpixmap;
	GtkStyle* style;
	GdkGC *gc;

	style = gtk_widget_get_default_style();
	gc = style->black_gc;
	gdkpixmap = gdk_pixmap_create_from_xpm_d(window->widget()->window, &mask,
			&style->bg[GTK_STATE_NORMAL],
			xpm);
	pixmap = gtk_pixmap_new(gdkpixmap, mask);
	return pixmap;
}

GtkWidget* newPixmapFromXpmFile(char filename[], Window* window)
{
	GtkWidget* pixmap;
	GdkBitmap* mask;
	GdkPixmap* gdkpixmap;
	GtkStyle* style;
	GdkGC *gc;

	style = gtk_widget_get_default_style();
	gc = style->black_gc;
	gdkpixmap = gdk_pixmap_create_from_xpm(window->widget()->window, &mask,
			&style->bg[GTK_STATE_NORMAL],
			filename);
	pixmap = gtk_pixmap_new(gdkpixmap, mask);
	return pixmap;
}
