//spin.cpp



#include <gnome.h>
#include "theme.h"
#include "widget.h"
#include "spin.h"


Spin::Spin(gfloat rate, guint digits,
		gfloat value, gfloat lower, gfloat upper,
		gfloat step, gfloat page)
{
	GtkAdjustment* adj = (GtkAdjustment*)
		gtk_adjustment_new(value, lower, upper, step, page, 0);
	_widget = gtk_spin_button_new(adj, rate, digits);
}

//returns
gfloat Spin::getValue()
{
	return gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(_widget));
}

gint Spin::getValueAsInt()
{
	return gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(_widget));
}

//sets
void Spin::setValue(gfloat value)
{
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(_widget), value);
}

void Spin::add(gfloat value)
{
	gtk_spin_button_spin(GTK_SPIN_BUTTON(_widget),  GTK_SPIN_STEP_FORWARD, value);
}

void Spin::remove(gfloat value)
{
	gtk_spin_button_spin(GTK_SPIN_BUTTON(_widget),  GTK_SPIN_STEP_BACKWARD, value);
}

//useful
void Spin::setDigits(guint digits)
{
	gtk_spin_button_set_digits(GTK_SPIN_BUTTON(_widget), digits);
}
