//widget.h



#ifndef __WIDGET_H
#define __WIDGET_H


class Widget
{
	protected:
		GtkWidget* _widget;
	public:
		Widget();
		Widget(GtkWidget* widget);
		~Widget();

		//returns
		GtkWidget* widget() { return _widget; }

		//sets
		void widget(GtkWidget* widget) { _widget = widget; }
		void setTheme(Theme* theme);

		//essentials
		void destroy();

		//useful
		void realize();
		void show();
		void hide();
		void canDefault();
		void hasDefault();
		void resize(gint width, gint height);
		void position(gint x, gint y);
		void sensitive(gboolean b);
		void tooltip(gchar text[]);
		void alignment(gfloat xalign, gfloat yalign);

		void signalConnect(gchar event[], void* func, gpointer data);

		//user data
		void setData(gpointer data);
		void setData(gint data);
		gpointer getData();
};

#endif //__WIDGET_H
